
#ifndef PCAP_CONFIG
#include <stdint.h>
#define PCAP_CONFIG
#define PROMISC                 1 // 1 means promiscous mode is on in pcap capture
#define TIMEOUT                 1000 // read timeout in milliseconds for pcap capture.


#define SDHASH_THRESHOLD 25
#define SDHASH_SAMPLE_SIZE 4
#define SDHASH_BLOCK_SIZE 0 //for block mode of sdhash. 0 to off

//multiple packet analysis
#define PACKET_PER_FILE 2
#define MATCH_PER_PACKET 2

#define MRSH "mr" 
#define SDHASH "sd"

//return values for connection_class
#define FILE_DETECTED 1
#define FILE_ADDED 0

typedef unsigned long long  uint64; 
typedef unsigned char       uchar;
typedef unsigned int        uint32;   

typedef struct{
    //group of flags used in the program
    int8_t  verbose_flag;
    int8_t  output_flag;
    int8_t  reverse_flag;
    int8_t  hash_list_flag;
    int8_t  statistics_flag;
    int8_t  mrsh_flag;
    int8_t  sdhash_flag;
    int8_t  offline_flag;
    int8_t  write_packet_flag;
	int8_t 	mutliple_packet_analysis_flag;
    
    //variables to store file options
    int8_t  layer; /**< tcp/ip layer of operation */ 
    std::string algo; /**< algorithm to use*/
    std::string output_file; /**< writing output to a file instead of stdout*/
    std::string hash_list_name; /**< file containing list of hashed files*/
    std::string dump_filename; /**< offline mode pcap_dump input file*/
    std::string reverse_file_name; /**< file containing list of reverse hashed files*/
    std::string write_packet_filename; /**< network packets to files*/
    std::string dev; /**< interface to listen traffic*/
    std::string filter; /**< filter expression for pcap */
    
}sniffer_parameters;

#endif
