#ifndef PRINT_PKT_H
#define PRINT_PKT_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netinet/in_systm.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/types.h>
#include <pcap.h>
#include <errno.h>
#include "protocol_headers.h"

void 	write_eth_pkt_to_file(const u_char *eth, size_t len, char *filename);
void    write_ip_pkt_to_file(const u_char *ip, size_t len, char *filename);
void    write_tcp_pkt_to_file(const u_char *tcp,  size_t len, char *filename);
void    write_payload_pkt_to_file(const u_char *payload, size_t len, char *filename);
char    *get_ip_dir(char *buff);
char    *get_tcp_dir(char *buff);
char    *get_payload_dir(char *buff);
void    int_to_char(int num, char *buff);
void    print_hex_ascii_line(const u_char *payload, int len, int offset);
void    print_payload(const u_char *payload, int len);
void    print_ip_header(const struct sniff_ip *ip);
void    print_tcp_header(const struct sniff_tcp *tcp);
void    print_ethernet_header(const struct sniff_ethernet *eth);

#endif
