#include "../header/connection_class.h"

//in desctructor: when object destroyed clean the hashtable
connection::connection(string source_ip, string dest_ip, unsigned short source_port, unsigned short dest_port )
{
    this->source_ip = source_ip;
    this->dest_ip = dest_ip;
    this->source_port = source_port;
    this->dest_port = dest_port;
}
string connection::get_source_ip(){
    return this->source_ip;
}

string connection::get_dest_ip(){
    return this->dest_ip;
}

unsigned short connection::get_source_port(){
    return this->source_port;
}

unsigned short connection::get_dest_port(){
    return this->dest_port;
}

void connection::clear_file_packet_map(){
    this->file_match_counter.clear();
}

int connection::add_file_to_map(string filename)
{
    // add packet count to the file, if it reaches the threshold, return file detected 
    // clear the table
    it = file_match_counter.find(filename);
    //check if the file detected
    if(it!=file_match_counter.end()) 
    {
        file_match_counter[filename] += 1; 
        //check for the number of packets matched for the file
        if(file_match_counter[filename] == PACKET_PER_FILE)
        {
            clear_file_packet_map();
            return FILE_DETECTED;
        }
    }
    else if (it == file_match_counter.end())
    {
        file_match_counter[filename] = 1;
        return FILE_ADDED;
    }
    else
    {
        cerr << "[!] Error in Map \n" ;
    }
}


