/* 
 * File:   bloom.h
 * Author: Frank Breitinger
 *
 * Created on 17. April 2013, 23:34
 */

#ifndef FINTERPRINTLIST_H
#define	FINTERPRINTLIST_H

#include "fingerprint.h"
#include <stdint.h>





typedef struct {
    //List of fingerprints, created on reading a file having many hashes
    FINGERPRINT *list;
    FINGERPRINT *last_element;
    
    // size of the list, used while freeing the memory
    unsigned int size;
    
}FINGERPRINT_LIST;

typedef struct MATCH_RESULT MATCH_RESULT;

struct MATCH_RESULT{
    char *filename1;
	char *filename2;
    uint32_t score;
	MATCH_RESULT *next;
};

typedef struct{
	MATCH_RESULT *head;
	MATCH_RESULT *tail;
	uint32_t total_length;
}MATCH_LIST;




FINGERPRINT_LIST    *init_empty_fingerprintList();
FINGERPRINT_LIST 	*init_fingerprintList_for_ListFile(char *filename);
int                 fingerprintList_destroy(FINGERPRINT_LIST *fpl);

void                add_new_fingerprint(FINGERPRINT_LIST *fpl, FINGERPRINT *fp);

void                all_against_all_comparsion(FINGERPRINT_LIST *fpl);
void                fingerprint_list_comparsion(FINGERPRINT_LIST *fpl2, FINGERPRINT_LIST *fpl1);
void 				fingerprint_against_list_comparison(FINGERPRINT_LIST *fpl, FINGERPRINT *fp,MATCH_LIST *match_list);

void                print_fingerprintList(FINGERPRINT_LIST *fpl);

unsigned int        read_fingerprint_file(FINGERPRINT_LIST *bloom_arr, FILE *handle);
MATCH_RESULT			*initialize_empty_match_result();
MATCH_LIST			*initialize_match_list();
void 				add_to_match_list(MATCH_LIST *list, char *filename1,char *filename2, uint32_t score);
void 				destroy_match_list(MATCH_LIST *match_list);



#endif	/* BLOOM_H */




