#include "../header/print_pkt.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>

extern char *write_packet_filename; 
extern long packet_count;

void int_to_char(int num, char *buff){
    /*convert the integer to a char array*/
    sprintf(buff, "%d", num);
}
/*returns the file to save the ip packets*/
char *get_eth_dir(char *buff)
{
    strcpy(buff, write_packet_filename);
    strcat(buff, "/eth");
    return buff;
}
char *get_ip_dir(char *buff)
{
    strcpy(buff, write_packet_filename);
    strcat(buff, "/ip");
    return buff;
}
char *get_tcp_dir(char *buff)
{
    strcpy(buff, write_packet_filename);
    strcat(buff, "/tcp");
    return buff;
}
char *get_payload_dir(char *buff)
{
    strcpy(buff, write_packet_filename);
    strcat(buff, "/payload");
    return buff;
}

void print_hex_ascii_line(const u_char *payload, int len, int offset)
{

    int i;
    int gap;
    const u_char *ch;
    //FILE *payload_file;
    /*offset*/
    printf("%05d    ", offset);

    /* hex*/
    ch = payload;
    for(i=0;i < len; i++){
        printf("%02x ", *ch);
        ch++;
        //print extra space after 8th byte for visual aid
        if(i ==7)
            printf("/n");
    }
    //print space to handle line less than 8 bytes
    if(len < 8)
        printf("  ");

    //fill hex gap with spaces if not full line
    if(len < 16)
    {
        gap = 16 -len;
        for ( i =0;i<gap;i++){
            printf(" ");
        }
    }
    printf("  ");

   //ascii if printable
    ch = payload;
    for(i=0;i<len;i++){
        /*isprint checks whether the character is a printable character*/
        if(isprint(*ch))
        {
            printf("%c", *ch);
        }
        else
            printf(".");
        ch++;
    }
    printf("/n");
    return;
}

void write_eth_pkt_to_file(const u_char *eth, size_t len,char *file_name){
	errno = 0;
    FILE *eth_file;
    int j;
    char pkt_count_char[20];
    int_to_char(packet_count, pkt_count_char);

    char *filename_append;
    filename_append = (char *) calloc(1024, sizeof(char));
    strcpy(filename_append,"packet/eth/");
    strcat(filename_append,file_name); 
    if((mkdir(filename_append, S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH)==-1))
    {
       // printf ("error creating output directory");
    }
    strcat(filename_append,"/");
    //strcat(filename_append,"_");
    strcat(filename_append, pkt_count_char);
    eth_file = fopen(filename_append, "w");
   
    if(eth_file != NULL)
    {
        fwrite(eth, sizeof(unsigned char), len, eth_file);
        fclose(eth_file);
    }
    else
    {
        printf("Problem in opening file:: ERROR NO: %d \n",errno);
    }
    free(filename_append);
}

void write_ip_pkt_to_file(const u_char *ip, size_t len,char *file_name)
{

    errno = 0;
    /*print the packet with ip header into a file*/
    FILE *ip_file;
    int j;
    char pkt_count_char[20];
    int_to_char(packet_count, pkt_count_char);

    char *filename_append;
    filename_append = (char *) calloc(1024, sizeof(char));
    strcpy(filename_append,"packet/ip/");
    strcat(filename_append,file_name); 
    if((mkdir(filename_append, S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH)==-1))
    {
        //printf ("error creating output directory");
    }
    strcat(filename_append,"/");
    //strcat(filename_append,"_");
    strcat(filename_append, pkt_count_char);
    ip_file = fopen(filename_append, "w");
   
    if(ip_file!= NULL)
    {
        fwrite(ip, sizeof(unsigned char), len, ip_file);
        fclose(ip_file);
    }
    else{
        printf("Problem in opening file:: ERROR NO: %d \n",errno);
    }
    free(filename_append);
}


void write_tcp_pkt_to_file(const u_char *tcp,  size_t len, char *file_name)
{
    FILE *tcp_file;
    int j;
    char pkt_count_char[20];
    int_to_char(packet_count, pkt_count_char);

    char *filename_append;
    filename_append = (char *) calloc(1024, sizeof(char));
    //char filename_append[1024] = "packet/tcp/"; 
    strcpy(filename_append,"packet/tcp/");
    strcat(filename_append,file_name); 
    if((mkdir(filename_append, S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH)==-1))
    {
       // printf ("error creating output directory");
    }
    strcat(filename_append,"/");
    //strcat(filename_append,"_");
    strcat(filename_append, pkt_count_char);
     tcp_file = fopen(filename_append, "w");

    if(tcp_file!= NULL)
    {
        fwrite(tcp, sizeof(unsigned char), len, tcp_file);
        fclose(tcp_file);
    }
    else{
        printf("Problem in opening file\n");
    }
    free(filename_append);
    
}

void write_payload_pkt_to_file(const u_char *payload, size_t len, char *file_name){
    FILE *payload_file;
    int j;

    char pkt_count_char[20];
    int_to_char(packet_count, pkt_count_char);

    char *filename_append;
    filename_append = (char *) calloc(1024, sizeof(char));
    strcpy(filename_append,"packet/payload/");
    strcat(filename_append,file_name); 
    if((mkdir(filename_append, S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH)==-1))
    {
        //printf ("error creating output directory \n");
    }
    strcat(filename_append,"/");
    //strcat(filename_append,"_");
    strcat(filename_append, pkt_count_char);
    payload_file = fopen(filename_append, "w");

    if(payload_file != NULL)
    {
       fwrite(payload, sizeof(unsigned char), len, payload_file);
       fclose(payload_file);
    }
    else{
        printf("Problem in opening file \n");

    }
    free(filename_append);
}

void print_ethernet_header(const struct sniff_ethernet *eth){
    if(sizeof(eth) == 0){
        printf("ETHERNET PACKET IS EMPTY \n");
        return;
    }
    else
    {
        //TODO not printing the host and destination
        printf("ETHERNET Destination: %s \n",eth->ether_dhost);
        printf("ETHERNET source: %s \n", eth->ether_shost);
        printf("ETHERNET type: %u \n", eth->ether_type);
    }
}

void print_tcp_header(const struct sniff_tcp *tcp)
{
    if(sizeof(tcp)==0){
        printf("TCP PACKET IS EMPTY \n");
        return;
    }

    else{
        printf("\n********TCP HEADER*********\n");
        printf("TCP source port: %u \n",ntohs( tcp->th_sport));
        printf("TCP destination port: %u \n",ntohs( tcp->th_dport));
        printf("TCP sequence number: %d \n", ntohs(tcp->th_seq));
        printf("TCP ack number : %d \n", ntohs(tcp->th_ack));
        printf("TCP offset: %u \n", tcp->th_offx2);
        printf("TCP flags : %u \n", tcp->th_flags);
        printf("TCP window: %u \n", ntohs(tcp->th_win));
        printf("TCP checksum: %u \n", ntohs(tcp->th_sum));
        printf("TCP urgent pointer: %u \n", ntohs(tcp->th_urp));
    }
}
void print_ip_header(const struct sniff_ip *ip){
    /*function ntohs() is used to convert network bytes to host bytes. only used one the size of the variable is more than 1 bytes. eg u_shocrt*/
    if(sizeof(ip)==0){
        printf("IP PACKET IS EMPTY");
        return;
    }

    else{
        printf("\n********IP HEADER*********\n");
        /*determine protocol*/
        switch(ip->ip_p){
            case IPPROTO_TCP:
                printf("protocol:TCP \n");
                break;
            case IPPROTO_UDP:
                printf("protocol:UDP \n");
                break;
            case IPPROTO_ICMP:
                printf("protocol:ICMP \n");
                break;
            case IPPROTO_IP:
                printf("protocol:IP \n");
                break;
            default:
                printf("Protocol:Unknown \n");
                return;
        }  
        printf("IP version:%u \n", IP_V(ip));
        printf("IP header length: %u \n", IP_HL(ip)*4);
        printf("IP type of service : %u \n", ip->ip_tos);
        printf("IP total lenght of packet: %u \n",ntohs( ip->ip_len));
        printf("IP identification : %u \n", ntohs(ip->ip_id));
        printf("IP fragment offset field: %u \n ", ntohs(ip->ip_off));
        printf("IP time to live : %u \n", ip->ip_ttl);
        printf("IP protocol: %u \n", ip->ip_p);
        printf("IP checksum: %u \n", ntohs(ip->ip_sum));
        printf("IP src: %s \n",inet_ntoa( ip->ip_src));
        printf("IP dest: %s \n", inet_ntoa(ip->ip_dst));
    }


}
/*print packet payload data (avoid printinchar(cg binary data)*/
void print_payload(const u_char *payload, int len)
{

    int len_rem = len;
    int line_width = 16;			/* number of bytes per line */
    int line_len;
    int offset = 0;					/* zero-based offset counter */
    const u_char *ch = payload;

    if (len <= 0)
        return;

    /* data fits on one line */
    if (len <= line_width) {
        print_hex_ascii_line(ch, len, offset);
        return;
    }

    /* data spans multiple lines */
    for ( ;; ) {
        /* compute current line length */
        line_len = line_width % len_rem;
        /* print line */
        print_hex_ascii_line(ch, line_len, offset);
        /* compute total remaining */
        len_rem = len_rem - line_len;
        /* shift pointer to remaining bytes to print */
        ch = ch + line_len;
        /* add offset */
        offset = offset + line_width;
        /* check if we have line width chthesisars or less */
        if (len_rem <= line_width) {
            /* print last line and get out */
            print_hex_ascii_line(ch, len_rem, offset);
            break;
        }
    }

    return;
}


