/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>

#include <protocol/TBinaryProtocol.h>
#include <transport/TSocket.h>
#include <transport/TTransportUtils.h>

#include "sdhashsrv.h"

using namespace std;
using namespace apache::thrift;
using namespace apache::thrift::protocol;
using namespace apache::thrift::transport;

using namespace sdhash;

using namespace boost;

int main(int argc, char** argv) {
  boost::shared_ptr<TTransport> socket(new TSocket("localhost", 9090));
  boost::shared_ptr<TTransport> transport(new TBufferedTransport(socket));
  boost::shared_ptr<TProtocol> protocol(new TBinaryProtocol(transport));
  sdhashsrvClient client(protocol);

  try {
    transport->open();

    client.ping();
    printf("ping()\n");

    std::string mylist;
	client.setList(mylist);
    printf("list: %s\n", mylist.c_str());

    std::string mydisp;
	client.displaySet(mydisp,1);
    printf("set 1:\n%s", mydisp.c_str());
	client.displaySet(mydisp,3);
    printf("set 3:\n%s", mydisp.c_str());
//	client.displayContents(mydisp,3);
 //   printf("set 3:\n%s", mydisp.c_str());
/*
	int32_t setnum =-1;
	setnum= client.loadSet("nothing");
	printf("set %d loaded\n",setnum);
	client.setList(mylist);
    printf("list: %s\n", mylist.c_str());
	setnum=-1;
	setnum= client.loadSet("foo");
	printf("set %d loaded\n",setnum);
	client.setList(mylist);
    printf("list: %s\n", mylist.c_str());
	setnum=-1;
	setnum= client.loadSet("kitten.sdbf");
	printf("set %d loaded\n",setnum);
	client.setList(mylist);
    printf("list: %s\n", mylist.c_str());
	client.displaySet(mydisp,setnum);
	cout << "set num " << setnum << ": ";
	cout << mydisp;
	std::string result;
	client.compareAll(result,1,1);
     cout << "result set 1: " << result << endl;

*/
	//client.querySet(result,3,4,1,0);
    //cout << "result set 3 vs 4: " << result << endl;
	cout << mylist;
	//int res =client.saveSet(3,"savedSet3.sdbf");
	int newnum=client.createView("new6.3",4,"6.3a");
	client.displaySet(mydisp,newnum);
	cout << "set num " << newnum << ": ";
	cout << mydisp;
	client.hashList("/home/candice/hashme.txt",0);
	//client.displaySet(mydisp,newnum);
	//cout << "set num " << newnum << ": ";
	//cout << mydisp;

    transport->close();
  } catch (TException &tx) {
    printf("ERROR: %s\n", tx.what());
  }

}
