#include "sdbf_class.h"
#include "sdbf_defines.h"

#include <boost/regex.hpp>
#include <boost/filesystem.hpp>

#include <iostream>
#include <iomanip>
#include <sstream>
#include <string>
#include <fstream>
using namespace std;

namespace fs = boost::filesystem;

/** view_set returns a SQL style "view" on a set via a regular expression match on file name.
	\param source_set set to search
	\param expression string to match in a grep-style regex
*/
sdbf_set*
create_view(sdbf_set *source_set,char *expression) {
	boost::regex rx(expression);

	sdbf_set *tmp=new sdbf_set(); 
	for (int i=0; i < source_set->size() ; i++) {
		if (boost::regex_search((source_set->at(i))->name(),rx)) {
			tmp->add(source_set->at(i));
		}
	}
	return tmp;
}
